10 'PC2CPC Parallel Link DSK transfer utility
20 '(C) James Churchill 1997
30 'Thanks to Marco Vieth for parallel transfer source
40 :
50 MODE 2
60 PRINT CHR$(150)+STRING$(78,154)+CHR$(156); 
70 PRINT CHR$(149)+"       PC2CPC v2.0 - DSK Parallel Transfer Utility - Rekall Systems 1997      "+CHR$(149);
80 PRINT CHR$(151)+STRING$(78,154)+CHR$(157);
90 PRINT CHR$(149)+"                 By James Churchill  s2191231@cse.unsw.edu.au                 "+CHR$(149);
100 PRINT CHR$(151)+STRING$(78,154)+CHR$(157); 
110 PRINT CHR$(149)+"                      Please wait - loading M/C segment.                      "+CHR$(149);
120 PRINT CHR$(147)+STRING$(78,154)+CHR$(153);
125 :
130 MEMORY &7DFF:DEFINT a-z
140 code=&9000:dib=&7E00:tob=&7E34:tib=&7F00:sct=&8000:' M/C and data locations
150 ' Load M/C
160 IF PEEK(&9005)=144 THEN GOTO 230
170 READ a$:counter=0:chksum!=0
180 WHILE a$<>"end"
190 b=VAL("&"+a$):POKE code+counter,b
200 counter=counter+1:chksum!=chksum!+b:READ a$
210 WEND
220 READ chk!:IF UNT(chksum!)<>chk! THEN PRINT"M/C data error! Please check the data.":END
230 CALL code:' activate RSX's
235 :
240 LOCATE 1,6
250 PRINT CHR$(149)+"            Enter PCPARA /s filename.DSK on PC then press any key.            "+CHR$(149);
260 PRINT CHR$(149)+"   WARNING: All data on the disk in the drive will be irrevocably destroyed!  "+CHR$(149);
270 PRINT CHR$(147)+STRING$(78,154)+CHR$(153);:CALL &BB18
280 LOCATE 1,6
290 PRINT CHR$(149)+"Receiving EDSK image:                                     Number of tracks: 00"+CHR$(149);
300 PRINT CHR$(151)+STRING$(78,154)+CHR$(157);
310 PRINT CHR$(149)+"                                   Track: 00                                  "+CHR$(149);
320 PRINT CHR$(149)+"                                  Sector: 00                                  "+CHR$(149);
330 PRINT CHR$(147)+STRING$(78,154)+CHR$(153);
335 :
340 filename$=SPACE$(255): 'reserve space for getstring
350 |RECSTR,@filename$
360 LOCATE 24,6:PRINT filename$
370 ' Receive disk information block
380 |RECBLK,dib,&100
390 chk$=CHR$(PEEK(dib))+CHR$(PEEK(dib+1)):' Retrieve first two chars of dib
400 IF chk$<>"EX" THEN LOCATE 1,11:PRINT filename$;" isn't an Extended DSK file!":END
410 numtracks=PEEK(dib+&30):heads=PEEK(dib+&31):LOCATE 78,6:PRINT USING "##";numtracks
420 IF numtracks>42 OR heads<>1 THEN LOCATE 1,11:PRINT"Sorry, DSK won't fit on a 3" disk side!":end
430 ' Main Loop
440 FOR trkloop=0 TO numtracks-1
445 LOCATE 44,8:PRINT USING "##";trkloop
450 trksize=PEEK(tob+trkloop)*256:IF trksize=0 THEN GOTO 700
460 |RECBLK,tib,&100:'Get Track Information Block
465 :
470 bps=PEEK(tib+&14):rbps=bps*&100:spt=PEEK(tib+&15):gap=PEEK(tib+&16):fil=PEEK(tib+&17)
480 firstnum=&100:FOR i=0 TO spt-1:firstnum=MIN(firstnum,PEEK(tib+&1A+(8*i))):NEXT
490 POKE &A89F,firstnum:POKE &A8A0,spt:POKE &A8A3,fil
500 logbps=LOG10(rbps)/LOG10(2)-7:POKE &A8A4,logbps
510 POKE &A8A5,bps/2:POKE &A8A8,&FF
515 :
520 ' Build format header string
530 hdr$="":FOR hdrloop=0 TO spt-1
540 hdr$=hdr$+CHR$(trkloop)+CHR$(0)+CHR$(PEEK(tib+&1A+(8*hdrloop)))+CHR$(logbps)
550 NEXT hdrloop
560 ' Format track
570 LOCATE 25,8:PRINT"Formatting"
580 |FORMAT,trkloop,@hdr$
581 LOCATE 25,8:PRINT"          "
585 :
590 ' Write all sectors
595 LOCATE 28,9:PRINT"Writing"
600 FOR sctloop=0 TO spt-1
610 sctrnum=PEEK(tib+&1A+(8*sctloop)):LOCATE 44,9:PRINT HEX$(sctrnum,2)
620 dbps=PEEK(tib+&1E+(8*sctloop))+(PEEK(tib+&1F+(8*sctloop))*256):'determine size of sector data in DSK
630 |RECBLK,sct,dbps
640 |WRITESCTR,trkloop,sctrnum,sct
650 NEXT sctloop
655 LOCATE 28,9:PRINT"       "
660 'IF spt=9 THEN 700
670 'FOR i=1 TO 9-spt
680 '|RECBLK,sct,rbps
690 'NEXT
700 NEXT trkloop
710 OUT &EF00,0:OUT &EF00,255:PRINT:PRINT"It's complete! Your disk is now ready for use.":POKE &A8A8,0:END
1990 :
2000 DATA 01,0D,90,21,09,90,C3,D1,BC,00
2010 DATA 00,00,00,1B,90,C3,37,90,C3,48
2020 DATA 91,C3,72,90,C3,94,90,52,45,43
2030 DATA 42,4C,CB,52,45,43,53,54,D2,46
2040 DATA 4F,52,4D,41,D4,57,52,49,54,45
2050 DATA 53,43,54,D2,00,FE,02,C0,E5,D5
2060 DATA C5,DD,5E,00,DD,56,01,DD,6E,02
2070 DATA DD,66,03,ED,4B,70,90,78,B1,C2
2080 DATA 59,90,CD,B3,90,DA,52,90,4F,CD
2090 DATA B3,90,DA,59,90,77,23,1B,0B,7A
2100 DATA B3,C2,4D,90,ED,43,70,90,C1,D1
2110 DATA E1,C9,00,00,FE,02,C0,E5,D5,C5
2120 DATA DD,6E,00,DD,66,01,DD,56,02,DD
2130 DATA 5E,03,23,4E,23,46,C5,E1,DF,91
2140 DATA 90,C1,D1,E1,C9,42,C0,07,FE,03
2150 DATA C0,E5,D5,C5,DD,6E,00,DD,66,01
2160 DATA DD,4E,02,DD,56,04,DD,5E,05,DF
2170 DATA B0,90,C1,D1,E1,C9,3F,C0,07,C5
2180 DATA D5,E5,11,20,4E,06,F5,ED,78,E6
2190 DATA 40,6F,3E,BF,06,EF,ED,79,06,F5
2200 DATA ED,78,4F,E6,40,AD,20,06,1B,7A
2210 DATA B3,20,F1,37,F5,3E,FF,06,EF,ED
2220 DATA 79,F1,38,3A,1E,00,16,08,F3,21
2230 DATA 10,27,06,F5,79,E6,40,4F,ED,78
2240 DATA E6,40,A9,20,08,2B,7C,B5,20,F4
2250 DATA 37,18,1D,3E,DF,06,EF,ED,79,ED
2260 DATA 79,06,F5,ED,78,FB,4F,17,17,CB
2270 DATA 1B,06,EF,3E,FF,ED,79,15,20,CC
2280 DATA A7,7B,E1,D1,C1,FB,C9,CD,B3,90
2290 DATA 38,23,77,B7,37,28,1E,47,23,7E
2300 DATA 23,66,6F,04,18,12,11,0A,00,CD
2310 DATA B3,90,30,08,1B,7A,B3,20,F6,37
2320 DATA 18,05,77,23,10,EC,A7,C9,FE,01
2330 DATA C0,DD,6E,00,DD,66,01,E5,CD,1F
2340 DATA 91,E1,D0,36,00,C9,end,&A490
